# Assign environment role

`POST /v1/environments/{environmentId}/role-assignment`

Available as MCP tool `post-env-role` (Write).

Access control endpoints allow you to review and manage user role assignments. Organization and environment roles are managed separately. Furthermore, a user’s organizational role doesn't impact their assigned environment role, and vice versa. [Learn about roles](https://docs.redoxengine.com/permalink/1OBel3inQAjAnDbgd9QLzM). 

Generally, organization owners or admins can retrieve, assign, update, or remove role assignments. However, only organization owners can assign or remove organization roles specifically.

Organization owners and admins can create and manage access control groups. A group allows you to manage role assignments for an entire group of users at once. [Learn about groups](https://docs.redoxengine.com/permalink/1OBel3inQAjAnDbgd9QLzM/#assign-roles-with-groups).

> **Assign or add an organization role**
>
> We don't currently support assigning an organization role (i.e., adding a user to an organization) in the Redox dashboard. [Learn how to add a user](https://docs.redoxengine.com/permalink/5c0Yr43tA3HrfvhX2JR3WS).

### Assign environment role

Assign a user to the specified environment role.

A user may only have one role per environment, but if they're part of multiple environments, they can have different roles assignments in different environments. 

You must be an organization owner or admin to assign user roles.

## Request parameters

| Name | In | Type | Required | Description |
| --- | --- | --- | --- | --- |
| `environmentId` | path | string | Yes | Identifies the specific environment that you're operating in or on behalf of. |

## Request body

Contains the user and the assigned role to add to the specified environment.

| Field | Type | Required | Description |
| --- | --- | --- | --- |
| `role` | object | Yes |  |
| `role.id` | string | Yes | Contains the uuid of the role permission. |
| `role.name` | string | No | Contains the role's human-readable name. |
| `user` | object | Yes |  |
| `user.id` | integer | Yes | Contains the unique identifier of the user. |
| `user.name` | string | No | Contains the user's human-readable name. |

## Request example

_Generated from the schema: the values are placeholders, not a real payload._

```bash
curl 'https://api.redoxengine.com/platform/v1/environments/{environmentId}/role-assignment' \
--request POST \
--header 'Authorization: Bearer $API_TOKEN' \
--header 'accept: application/json' \
--header 'Content-Type: application/json' \
--data '{
  "role": {
    "id": "string",
    "name": "string"
  },
  "user": {
    "id": 0,
    "name": "string"
  }
}'
```

## Responses

### 200

Contains the payload with status of the request.

| Field | Type | Required | Description |
| --- | --- | --- | --- |
| `meta` | object | No |  |
| `meta.version` | string | No | Lists the major and minor version number for the format of the returned payload. The payload format or shape may change between minor versions, like including additional or extended fields in later versions. We include the version data in each response so that you have the option to handle the signaled differences. |
| `payload` | object | No | Contains the payload with details about the requested environment memberships. |
| `payload.success` | boolean | No | Displays the status of the request. |

_Generated from the schema: the values are placeholders, not a real payload._

```json
{
  "meta": {
    "version": "1.0.0"
  },
  "payload": {
    "success": true
  }
}
```

### 400

Bad Request

| Field | Type | Required | Description |
| --- | --- | --- | --- |
| `payload` | object | No | Contains the error message. |
| `payload.error` | object | No | Contains the error message details. |
| `payload.error.id` | string | No | Contains a unique identifier for the given error instance. |
| `payload.error.title` | string | No | Displays the high-level error message, typically something succinct like `Bad Request`. |
| `payload.error.code` | string | No | Contains an alternative ID for the error type, which can be used to find relevant troubleshooting information. |
| `payload.error.detail` | string | No | Contains the specific error details for this message. |
| `payload.error.status` | number | No | Displays the corresponding HTTP status code for the error. |
| `payload.error.transient` | boolean | No | Describes whether the error will resolve itself. If `true`, no further action needs to be taken. If `false`, you may need to troubleshoot on your end to resolve the issue before the error can be processed. |

```json
{
  "payload": {
    "error": {
      "title": "Bad Request",
      "code": "validation.error.bad.request",
      "detail": "Error details",
      "status": 400,
      "transient": false
    }
  }
}
```

### 403

Forbidden

| Field | Type | Required | Description |
| --- | --- | --- | --- |
| `payload` | object | No | Contains the error message. |
| `payload.errors` | Array of object | No |  |
| `payload.errors[].title` | string | No | Displays the high-level error message, typically something succinct like `Forbidden`. |
| `payload.errors[].code` | string | No | Contains an alternative ID for the error type, which can be used to find relevant troubleshooting information. |

```json
{
  "payload": {
    "errors": [
      {
        "title": "Forbidden",
        "code": "authorization.forbidden"
      }
    ]
  }
}
```

### 500

Internal Server Error

| Field | Type | Required | Description |
| --- | --- | --- | --- |
| `payload` | object | No | Contains the error message. |
| `payload.error` | object | No | Contains the error message details. |
| `payload.error.title` | string | No | Displays the high-level error message, typically something succinct like `Failed in step X`. |
| `payload.error.code` | string | No | Contains an alternative ID for the error type, which can be used to find relevant troubleshooting information. |
| `payload.error.detail` | string | No | Contains the specific error details for this message. |
| `payload.error.status` | number | No | Displays the corresponding HTTP status code for the error. |
| `payload.error.transient` | boolean | No | Describes whether the error will resolve itself. If `true`, no further action needs to be taken. If `false`, you may need to troubleshoot on your end to resolve the issue before the error can be processed. |

```json
{
  "payload": {
    "error": {
      "title": "Internal Server Error",
      "code": "failed.db.lookup",
      "detail": "Error details",
      "status": 500,
      "transient": true
    }
  }
}
```
